// ****************************************************************************
// copyright (c) 2000-2003 Horst Knorr <hk_classes@knoda.org>
// This file is part of the hk_classes library.
// This file may be distributed and/or modified under the terms of the
// GNU Library Public License version 2 as published by the Free Software
// Foundation and appearing in the file COPYING included in the
// packaging of this file.
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// ****************************************************************************
#include "hk_interpreter.h"
#include "hk_button.h"

#ifdef HAVE_PYTHON
#include <Python.h>
#endif

bool hk_no_interpreter::button_clicked(hk_button*)
{
warning();
return false;
}

void hk_no_interpreter::warning(void)
{
  show_warningmessage(hk_translate("No interpreter language installed!"));

}



#ifdef HAVE_PYTHON

hk_pythoninterpreter::hk_pythoninterpreter()
{
Py_Initialize();
}

hk_pythoninterpreter::~hk_pythoninterpreter()
{
Py_Exit(0);
}

bool hk_pythoninterpreter::button_clicked(hk_button* button)
{
if (!button)return false;
PyRun_SimpleString((char*)button->object().c_str());


return true;
}


#endif //HAVE_PYTHON
