// ****************************************************************************
// copyright (c) 2000-2002 Horst Knorr <hk_classes@knoda.org>
// This file is part of the hk_odbcclasses library.
// This file may be distributed and/or modified under the terms of the
// GNU Library Public License version 2 as published by the Free Software
// Foundation and appearing in the file COPYING included in the
// packaging of this file.
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// ****************************************************************************
#include <sql.h>
#include <sqltypes.h>
#include <sqlext.h>

#include <hk_odbcdatabase.h>
#include <hk_odbcconnection.h>
#include <hk_odbctable.h>
#include <hk_odbcresultquery.h>
#include <hk_odbcactionquery.h>
hk_odbcdatabase::hk_odbcdatabase(hk_odbcconnection* c):hk_database(c)
{
#ifdef HK_DEBUG
    hkdebug("hk_odbcdatabase::hk_odbcdatabase");
#endif
    p_odbcconnection=c;
}


hk_odbcdatabase::~hk_odbcdatabase(void)
{
#ifdef HK_DEBUG
    hkdebug("hk_odbcdatabase::~hk_odbcdatabase");
#endif

}


hk_odbcconnection* hk_odbcdatabase::connection(void)
{
    return p_odbcconnection;
}


vector<hk_string>* hk_odbcdatabase::driver_specific_tablelist(void)
{
#ifdef HK_DEBUG
    hkdebug("hk_odbcdatabase::driver_specific_tablelist");
#endif
    p_tablelist.erase(p_tablelist.begin(),p_tablelist.end());

    SQLHSTMT        hstmt;
    SQLRETURN   nReturn;
    SQLCHAR         szTableName[101]  = "";
    SQLCHAR         szTableType[1]    = "";
    SQLCHAR         szTableRemarks[1] = "";
    SQLINTEGER      nIndicatorName;

    nReturn = SQLAllocHandle(SQL_HANDLE_STMT, p_odbcconnection->connectionhandle(), &hstmt );
    if ( nReturn != SQL_SUCCESS )
    {
        show_warningmessage( "Failed to SQLAllocHandle STMT" );
        return &p_tablelist;
    }

    if ( SQL_SUCCESS != SQLTables( hstmt, 0, 0, 0, 0, 0, 0, 0, 0 ) )
    {
        show_warningmessage(  "Failed to SQLTables" );
        return &p_tablelist;
    }

    SQLBindCol( hstmt, 3/*tablename*/, SQL_C_CHAR, szTableName, sizeof(szTableName), &nIndicatorName );
// GET RESULTS
    nReturn = SQLFetch( hstmt );
    while ( nReturn == SQL_SUCCESS || nReturn == SQL_SUCCESS_WITH_INFO )
    {
        p_tablelist.insert(p_tablelist.end(),(char *)szTableName);

        szTableName[0]      = '\0';
        szTableType[0]      = '\0';
        szTableRemarks[0]   = '\0';
        nReturn = SQLFetch( hstmt );
    }

// FREE STATEMENT
    nReturn = SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
    if ( nReturn != SQL_SUCCESS )
        show_warningmessage(  "Failed to SQLFree Stmt" );

    sort(p_tablelist.begin(),p_tablelist.end());
    return &p_tablelist;
}


hk_datasource* hk_odbcdatabase::driver_specific_new_table(hk_presentation* p)
{
    return new hk_odbctable(this,p);
}


hk_datasource* hk_odbcdatabase::driver_specific_new_resultquery(hk_presentation* p)
{
    return new hk_odbcresultquery(this,p);
}


hk_actionquery* hk_odbcdatabase::driver_specific_new_actionquery(void)
{
    return new hk_odbcactionquery(this);
}


bool hk_odbcdatabase::driver_specific_select_db(void)
{
#ifdef HK_DEBUG
    hkdebug("hk_odbcdatabase::driver_specific_select_db");
#endif
    return true;
    if (p_odbcconnection!=NULL)
    {
        if (p_odbcconnection->is_connected())p_odbcconnection->disconnect();
        if (p_odbcconnection->connect())return true;
    }
    return false;
}


void hk_odbcdatabase::driver_specific_set_name(void)
{
    if (p_odbcconnection->is_connected())p_odbcconnection->disconnect();
    if (p_odbcconnection->connect())return ;

}
